<?php
namespace ApacheSolrForTypo3\Solr\Utility;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014-2015 Ingo Renner <ingo@typo3.org>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Database utility class to do things the core currently does not support
 *
 * @author Ingo Renner <ingo@typo3.org>
 */
class DatabaseUtility
{

    /**
     * Start a transaction
     *
     * @return void
     */
    public static function transactionStart()
    {
        $GLOBALS['TYPO3_DB']->sql_query('START TRANSACTION');
    }

    /**
     * Commit a transaction
     *
     * @return void
     */
    public static function transactionCommit()
    {
        $GLOBALS['TYPO3_DB']->sql_query('COMMIT');
    }

    /**
     * Roll back a transaction
     *
     * @return void
     */
    public static function transactionRollback()
    {
        $GLOBALS['TYPO3_DB']->sql_query('ROLLBACK');
    }
}
